f32c6d362d81f059d20a5c67a5fd0f2a65fdefa2
[EVA-2020-02.git] / exec / bkgpslog
1 #!/bin/bash
2
3 # Desc: Records gps data until midnight
4 # Author: Steven Baltakatei Sandoval; License: GPLv3+
5 # Usage: bkgpslog --output [output dir]
6
7 #==BEGIN Define script parameters==
8 PATH="/opt/bktei:$PATH" # Add default baltakatei script install directory to PATH (necessary for other bk scripts)
9 SCRIPT_HOSTNAME=$(hostname) # Save hostname of system running this script.
10 SCRIPT_VERSION="bkgpslog 0.0.1" # Define version of script.
11 SCRIPT_TIME_SHORT="$(date +%Y%m%dT%H%M%S%z)" # Save current date & time in ISO-8601 format.
12 SCRIPT_DATE_SHORT="$(date +%Y%m%d)" # Save current date in ISO-8601 format.
13
14 declare -Ag appRollCall # Associative array for storing app status
15 declare -Ag fileRollCall # Associative array for storing file status
16 declare -Ag dirRollCall # Associative array for storing dir status
17
18 #===BEGIN Declare local script functions===
19 checkapp() {
20 # Desc: If arg is a command, save result in assoc array 'appRollCall'
21 # Usage: checkapp arg1 arg2 arg3 ...
22 # Input: global assoc. array 'appRollCall'
23 # Output: adds/updates key(value) to global assoc array 'appRollCall'
24 local returnState
25 #echo "DEBUG:$(date +%S.%N)..Starting checkapp function."
26 #echo "DEBUG:args: $@"
27 #echo "DEBUG:returnState:$returnState"
28
29 #===Process Args===
30 for arg in "$@"; do
31 #echo "DEBUG:processing arg:$arg"
32 if command -v "$arg" 1>/dev/null 2>&1; then # Check if arg is a valid command
33 appRollCall[$arg]="true";
34 #echo "DEBUG:appRollCall[$arg]:"${appRollCall[$arg]}
35 if ! [ "$returnState" = "false" ]; then returnState="true"; fi
36 else
37 appRollCall[$arg]="false"; returnState="false";
38 fi
39 done
40
41 #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
42 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
43
44 #===Determine function return code===
45 if [ "$returnState" = "true" ]; then
46 #echo "DEBUG:checkapp returns true for $arg";
47 return 0;
48 else
49 #echo "DEBUG:checkapp returns false for $arg";
50 return 1;
51 fi
52 } # Check that app exists
53 checkfile() {
54 # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
55 # Usage: checkfile arg1 arg2 arg3 ...
56 # Input: global assoc. array 'fileRollCall'
57 # Output: adds/updates key(value) to global assoc array 'fileRollCall';
58 # Output: returns 0 if app found, 1 otherwise
59 local returnState
60
61 #===Process Args===
62 for arg in "$@"; do
63 #echo "DEBUG:processing arg:$arg"
64 if [ -f "$arg" ]; then
65 fileRollCall["$arg"]="true";
66 #echo "DEBUG:fileRollCall[\"$arg\"]:"${fileRollCall["$arg"]}
67 if ! [ "$returnState" = "false" ]; then returnState="true"; fi
68 else
69 fileRollCall["$arg"]="false"; returnState="false";
70 fi
71 done
72
73 #for key in "${!fileRollCall[@]}"; do echo "DEBUG:fileRollCall key [$key] is:${fileRollCall[$key]}"; done
74 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
75
76 #===Determine function return code===
77 if [ "$returnState" = "true" ]; then
78 #echo "DEBUG:checkapp returns true for $arg";
79 return 0;
80 else
81 #echo "DEBUG:checkapp returns false for $arg";
82 return 1;
83 fi
84 } # Check that file exists
85 checkdir() {
86 # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
87 # Usage: checkdir arg1 arg2 arg3 ...
88 # Input: global assoc. array 'dirRollCall'
89 # Output: adds/updates key(value) to global assoc array 'dirRollCall';
90 # Output: returns 0 if app found, 1 otherwise
91 local returnState
92
93 #===Process Args===
94 for arg in "$@"; do
95 #echo "DEBUG:processing arg:$arg"
96 if [ -d "$arg" ]; then
97 dirRollCall["$arg"]="true";
98 #echo "DEBUG:dirRollCall[\"$arg\"]:"${dirRollCall["$arg"]}
99 if ! [ "$returnState" = "false" ]; then returnState="true"; fi
100 elif [ "$arg" = "" ]; then
101 dirRollCall["$arg"]="false"; returnState="false";
102 else
103 returnState="false";
104 fi
105 done
106
107 #for key in "${!dirRollCall[@]}"; do echo "DEBUG:dirRollCall key [$key] is:${dirRollCall[$key]}"; done
108 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
109
110 #===Determine function return code===
111 if [ "$returnState" = "true" ]; then
112 #echo "DEBUG:checkapp returns true for $arg";
113 return 0;
114 else
115 #echo "DEBUG:checkapp returns false for $arg";
116 return 1;
117 fi
118 } # Check that dir exists
119
120 # Yell, Die, Try Three-Fingered Claw technique
121 # Ref/Attrib: https://stackoverflow.com/a/25515370
122 yell() { echo "$0: $*" >&2; }
123 die() { yell "$*"; exit 111; }
124 try() { "$@" || die "cannot $*"; }
125
126 echoerr() {
127 echo "$@" 1>&2; # Define stderr echo function.
128 } # Define stderr message function.
129 showUsage() {
130 echoerr "USAGE:"
131 echoerr " bkgpslog [ options ]"
132 echoerr
133 echoerr "OPTIONS:"
134 echoerr " -h, --help"
135 echoerr " Display help information."
136 echoerr
137 echoerr " --version"
138 echoerr " Display script version."
139 echoerr
140 echoerr " -v, --verbose"
141 echoerr " Display debugging info."
142 echoerr
143 echoerr " -o, --output [ directory ]"
144 echoerr " Specify output directory to save logs."
145 } # Display information on how to use this script.
146 showVersion() {
147 echoerr "$SCRIPT_VERSION"
148 } # Display script version.
149 vbm() {
150 # Usage: vbm "DEBUG:verbose message here"
151 # Description: Prints verbose message ("vbm") to stderr if OPTION_VERBOSE is set to "true".
152 # Input:
153 # - OPTION_VERBOSE variable set by processArguments function. (ex: "true", "false")
154 # - "$@" positional arguments fed to this function.
155 # Output: stderr
156 # Script function dependencies: echoerr
157 # External function dependencies: echo
158 # Last modified: 2020-04-11T23:57Z
159 # Last modified by: Steven Baltakatei Sandoval
160 # License: GPLv3+
161 # Ref./Attrib:
162
163 if [ "$OPTION_VERBOSE" = "true" ]; then
164 FUNCTION_TIME=$(date --iso-8601=ns); # Save current time in nano seconds.
165 echoerr "[$FUNCTION_TIME] ""$*"; # Display argument text.
166 fi
167
168 # End function
169 return 0; # Function finished.
170 } # Verbose message display function.
171 processArguments() {
172 while [ ! $# -eq 0 ]; do # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
173 echoerr "DEBUG:Starting processArguments while loop."
174 echoerr "DEBUG:Provided arguments are:""$*"
175 case "$1" in
176 --h | --help) showUsage; exit 1;; # Display usage.
177 --version) showVersion; exit 1;; # Show version
178 --v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
179 --o | --output) if [ -d "$2" ]; then DIROUT="$2"; vbm "DEBUG:DIROUT:$DIROUT"; shift; fi ;; # Define output directory.
180 *) echoerr "ERROR: Unrecognized argument."; exit 1;; # Handle unrecognized options.
181 esac
182 shift
183 done
184 } # Argument Processing
185 timeUntilMidnight(){
186 # Desc: Report seconds until midnight
187 # Output: stdout: integer seconds until midnight
188 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
189 # Usage: timeUntilMidnight
190 # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi
191 local returnState
192 TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
193 TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
194 DATE_CURRENT="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
195 DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day.
196 DATE_TOMORROW="$(date -d "$TIME_CURRENT next day" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
197 TIME_NEXT_MIDNIGHT="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second).
198 SECONDS_UNTIL_NEXT_MIDNIGHT="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
199 if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then
200 returnState="true";
201 elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then
202 returnState="WARNING_ZERO";
203 yell "WARNING:Reported time until midnight exactly zero.";
204 elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then
205 returnState="WARNING_NEGATIVE";
206 yell "WARNING:Reported time until midnight is negative.";
207 fi
208
209 try echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report
210
211 #===Determine function return code===
212 if [[ "$returnState" = "true" ]]; then
213 return 0;
214 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
215 return 1;
216 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
217 return 2;
218 fi
219 } # Report seconds until next midnight
220 dateTimeShort(){
221 # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
222 # Usage: dateTimeShort
223 # Output: stdout: timestamp (ISO-8601, no separators)
224 TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
225 TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
226 echo "$TIME_CURRENT_SHORT";
227 } # Get date&time without separators
228 main() {
229 processArguments "$@" # Process arguments.
230 if checkapp gpspipe && checkdir "$DIROUT"; then
231
232
233 # Determine script lifespan (note: exit if <= 0 since 'timeout' runs forever if provided "0s".
234 #if ! scriptTTL="$(timeUntilMidnight)"; then yell "ERROR: timeUntilMidnight exit code $?"; exit 1; fi
235 scriptTTL="3600"; # DEBUG DEBUG DEBUG DEBUG
236
237 # Determine buffer lifespan
238 bufferTTL="60";
239
240 # Record gps data until script lifespan ends
241 declare debugCounter; debugCounter="0"
242 while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
243 ((debugCounter++))
244 # Determine output file paths (time is start of buffer period)
245 FILEOUT_BASENAME="$(dateTimeShort)--P$(bufferTTL)S..""$SCRIPT_HOSTNAME""_location" ; # ISO-8601 YYYYmmddTHHMMSS+zzP[$bufferTTL]S
246 FILEOUT_NMEA="$FILEOUT_BASENAME".nmea ;
247 FILEOUT_GPX="$FILEOUT_BASENAME".gpx ;
248 FILEOUT_KML="$FILEOUT_BASENAME".kml ;
249 # Fill buffer
250 buffer="$(timeout "$bufferTTL""s" gpspipe -r)"; # Record gpspipe nmea data to buffer for bufferTTL seconds
251 # Process and save buffers
252 echo "$buffer" > "$DIROUT"/"$FILEOUT_NMEA" & # Save NMEA format
253 echo "$buffer" | gpsbabel -i nmea -f - -o gpx -F - > "$DIROUT"/"$FILEOUT_GPX" & # Save GPX format
254 echo "$buffer" | gpsbabel -i nmea -f - -o kml -F - > "$DIROUT"/"$FILEOUT_KML" & # Save KML format
255 vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
256 # Reset buffer and filenames
257 unset buffer buffer_GPX buffer_KML FILEOUT_BASENAME FILEOUT_NMEA FILEOUT_GPX FILEOUT_KML;
258 done
259 fi
260 } # Main function.
261 #===END Declare local script functions===
262 #==END Define script parameters==
263
264
265 #==BEGIN Perform work and exit==
266 main "$@" # Run main function.
267 exit 0;
268 #==END Perform work and exit==
269
270
271
272 #gpspipe -r -d -l -o "$DIROUT1"/"$FILEOUT1" ;